/*
	Standard definition
	(c) Copyright 1992/1994 Marco Savegnago IW3FQG
*/

#ifndef __TDEF_H
#define __TDEF_H

#include <stddef.h>

//	ANSI C++ Proposed bool type

class bool
{
	unsigned char state;
public:

	bool(int st = 0);
	operator int() const;
};


inline bool::bool(int st)
{
	state = !!st;
}

inline bool::operator int() const
{
	return state;
}

const bool true = 1;
const bool false = 0;

//	Level type

enum	Level		{	Low,    High 	};

#ifndef  _Windows
typedef int                 BOOL;

#ifndef	FALSE
#define FALSE               0
#endif

#ifndef	TRUE
#define TRUE                1
#endif

typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;

typedef unsigned char       UCHAR;
typedef unsigned short      UINT;
typedef unsigned long       ULONG;

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)((UINT)(w) >> 8))

#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)((DWORD)(l) >> 16))

#define MAKELONG(low, high) ((LONG)(((WORD)(low)) | (((DWORD)((WORD)(high))) << 16)))

#endif

#ifdef	__cplusplus

#if ! defined _TV_VERSION && ! defined UseWithTV

enum Boolean { False, True };

typedef int ccIndex;
typedef Boolean (*ccTestFunc)( void *, void * );
typedef void (*ccAppFunc)( void *, void * );

const 	ccNotFound = -1;

const 	maxCollectionSize = (int)((65536uL - 16)/sizeof( void * ));

#endif

typedef unsigned char   byte;
typedef unsigned short  word;
typedef unsigned long   dword;

inline int min(byte a, byte b) {return a<b ? a : b;}
inline int max(byte a, byte b) {return a>b ? a : b;}
inline int min(int a, int b) {return a<b ? a : b;}
inline int max(int a, int b) {return a>b ? a : b;}

#define lowByte(w)      (((byte *)&w)[0])
#define highByte(w)     (((byte *)&w)[1])

#define lowWord(dw)      (((word *)&dw)[0])
#define highWord(dw)     (((word *)&dw)[1])


#if sizeof(int) == 2
typedef int 	int16;	// 16 bit
#else
typedef short 	int16;	// 32 bit
#endif

#define EOS     '\0'
#define EOL     '\n'

#endif

#endif // !defined __TDEF_H

